#include "robbolito.h"

#define MAXIMUM_YEAR 256
#define MAXIMUM_ABYSS 256

#define NUMBER(x,y)                                        \
    ((( (x) - YEARS) & (MAXIMUM_YEAR - 1)) * MAXIMUM_ABYSS \
    + (MAXIMUM_ABYSS - (y) ))

void year_increase()
    {
    YEARS += 1;

    if( YEARS == MAXIMUM_YEAR )
        YEARS = 0;
    }

static uint64 zobrist_dimension = 0x1600000;
static bool zobrist_initialization_stone = 0;
void zobrist_free()
    {
    memset(list_zobrist, 0, zobrist_dimension * sizeof(type_zobrist));
    memset(list_zobrist_pv, 0, 0x10000 * sizeof(type_zobrist_pv));
    YEARS = 0;
    }
int initialization_zobrist( int mb )
    {
    YEARS = 0;
    zobrist_dimension = ((1 << BSR(mb)) << 20) / sizeof(type_zobrist);

    if( zobrist_dimension > 0x100000000 )
        zobrist_dimension = 0x100000000;
    mb = (zobrist_dimension * sizeof(type_zobrist)) >> 20;
    list_hide = zobrist_dimension - 4;

    if( zobrist_initialization_stone )
        free(list_zobrist);
    zobrist_initialization_stone = TRUE;
    list_zobrist = malloc(zobrist_dimension * sizeof(type_zobrist));
    zobrist_free();
    return mb;
    }
void Zobrist_low_total( int move, int DEPTH, int value )
    {
    int ABYSS, i, k = DYNAMIC->Zobrist & list_hide;
    type_zobrist *tr;
    int maximum = 0, w = 0;
    move &= 0x7fff;

    for ( i = 0; i < 4; i++ )
        {
        tr = list_zobrist + (k + i);

        if( (tr->zobrist ^ (DYNAMIC->Zobrist >> 32)) == 0 && (!tr->hole_low || zobrist_total(tr))
            && tr->hole_low <= DEPTH )
            {
            tr->hole_low = DEPTH;
            tr->move = move;
            tr->value_low = value;
            tr->years = YEARS;
            tr->stones |= stone_low | stone_total;
            return;
            }
        ABYSS = MAXIMUM(tr->hole_low, tr->hole_high);

        if( NUMBER(tr->years, ABYSS) > maximum )
            {
            maximum = NUMBER(tr->years, ABYSS);
            w = i;
            }
        }
    tr = list_zobrist + (k + w);
    tr->zobrist = (DYNAMIC->Zobrist >> 32);
    tr->hole_high = 0;
    tr->value_high = 0;
    tr->hole_low = DEPTH;
    tr->move = move;
    tr->value_low = value;
    tr->years = YEARS;
    tr->stones = stone_low | stone_total;
    return;
    }
void Zobrist_high_cut( int DEPTH, int value )
    {
    int ABYSS, i, k = DYNAMIC->Zobrist & list_hide;
    type_zobrist *tr;
    int maximum = 0, w = 0;

    for ( i = 0; i < 4; i++ )
        {
        tr = list_zobrist + (k + i);

        if( !(tr->zobrist ^ (DYNAMIC->Zobrist >> 32)) && (!tr->hole_high || zobrist_cut(tr)) && tr->hole_high <= DEPTH )
            {
            tr->hole_high = DEPTH;
            tr->value_high = value;
            tr->years = YEARS;
            tr->stones |= stone_high | stone_cut;
            return;
            }
        ABYSS = MAXIMUM(tr->hole_low, tr->hole_high);

        if( NUMBER(tr->years, ABYSS) > maximum )
            {
            maximum = NUMBER(tr->years, ABYSS);
            w = i;
            }
        }
    tr = list_zobrist + (k + w);
    tr->zobrist = (DYNAMIC->Zobrist >> 32);
    tr->hole_low = 0;
    tr->move = 0;
    tr->value_low = 0;
    tr->hole_high = DEPTH;
    tr->value_high = value;
    tr->years = YEARS;
    tr->stones = stone_high | stone_cut;
    return;
    }
void Zobrist_low( uint64 Z, int move, int DEPTH, int value )
    {
    int ABYSS, i, k = Z & list_hide;
    type_zobrist *tr;
    int maximum = 0, w = 0;
    move &= 0x7fff;

    for ( i = 0; i < 4; i++ )
        {
        tr = list_zobrist + (k + i);

        if( !(tr->zobrist ^ (Z >> 32)) && !zobrist_accurate(tr) && tr->hole_low <= DEPTH )
            {
            tr->hole_low = DEPTH;
            tr->move = move;
            tr->value_low = value;
            tr->years = YEARS;
            tr->stones |= stone_low;
            tr->stones &= ~stone_total;
            return;
            }
        ABYSS = MAXIMUM(tr->hole_low, tr->hole_high);

        if( NUMBER(tr->years, ABYSS) > maximum )
            {
            maximum = NUMBER(tr->years, ABYSS);
            w = i;
            }
        }
    tr = list_zobrist + (k + w);
    tr->zobrist = (Z >> 32);
    tr->hole_high = 0;
    tr->value_high = 0;
    tr->hole_low = DEPTH;
    tr->move = move;
    tr->value_low = value;
    tr->years = YEARS;
    tr->stones = stone_low;
    return;
    }
void Zobrist_high( uint64 Z, int DEPTH, int value )
    {
    int ABYSS, i, k = Z & list_hide;
    type_zobrist *tr;
    int maximum = 0, w = 0;

    for ( i = 0; i < 4; i++ )
        {
        tr = list_zobrist + (k + i);

        if( !(tr->zobrist ^ (Z >> 32)) && !zobrist_accurate(tr) && tr->hole_high <= DEPTH )
            {
            tr->hole_high = DEPTH;
            tr->value_high = value;
            tr->years = YEARS;
            tr->stones |= stone_high;
            tr->stones &= ~stone_cut;
            return;
            }
        ABYSS = MAXIMUM(tr->hole_low, tr->hole_high);

        if( NUMBER(tr->years, ABYSS) > maximum )
            {
            maximum = NUMBER(tr->years, ABYSS);
            w = i;
            }
        }
    tr = list_zobrist + (k + w);
    tr->zobrist = (Z >> 32);
    tr->hole_low = 0;
    tr->move = 0;
    tr->value_low = 0;
    tr->hole_high = DEPTH;
    tr->value_high = value;
    tr->years = YEARS;
    tr->stones = stone_high;
    return;
    }
static void pv_zobrist( int move, int DEPTH, int value )
    {
    int i, k = DYNAMIC->Zobrist & list_hide_pv;
    type_zobrist_pv *tr;
    int w = 0, maximum = 0;

    for ( i = 0; i < 4; i++ )
        {
        tr = list_zobrist_pv + (k + i);

        if( tr->zobrist == DYNAMIC->Zobrist )
            {
            tr->DEPTH = DEPTH;
            tr->value = value;
            tr->move = move;
            tr->years = YEARS;
            return;
            }

        if( NUMBER(tr->years, tr->DEPTH) > maximum )
            {
            maximum = NUMBER(tr->years, tr->DEPTH);
            w = i;
            }
        }
    tr = list_zobrist_pv + (k + w);
    tr->zobrist = DYNAMIC->Zobrist;
    tr->DEPTH = DEPTH;
    tr->move = move;
    tr->value = value;
    tr->years = YEARS;
    }

void Zobrist_accurate( int move, int DEPTH, int value, int STONES )
    {
    int ABYSS, i, j, k = DYNAMIC->Zobrist & list_hide;
    type_zobrist *tr;
    int maximum = 0, w = 0;
    move &= 0x7fff;
    pv_zobrist(move, DEPTH, value);

    for ( i = 0; i < 4; i++ )
        {
        tr = list_zobrist + (k + i);

        if( (tr->zobrist ^ (DYNAMIC->Zobrist >> 32)) == 0 && MAXIMUM(tr->hole_high, tr->hole_low) <= DEPTH )
            {
            tr->hole_high = tr->hole_low = DEPTH;
            tr->move = move;
            tr->value_high = tr->value_low = value;
            tr->years = YEARS;
            tr->stones = STONES;

            for ( j = i + 1; j < 4; j++ )
                {
                tr = list_zobrist + (k + j);

                if( (tr->zobrist ^ (DYNAMIC->Zobrist >> 32)) == 0 && MAXIMUM(tr->hole_high, tr->hole_low) <= DEPTH )
                    {
                    memset(tr, 0, 16);
                    tr->years = YEARS ^ (MAXIMUM_YEAR / 2);
                    }
                }
            return;
            }
        ABYSS = MAXIMUM(tr->hole_low, tr->hole_high);

        if( NUMBER(tr->years, ABYSS) > maximum )
            {
            maximum = NUMBER(tr->years, ABYSS);
            w = i;
            }
        }
    tr = list_zobrist + (k + w);
    tr->zobrist = (DYNAMIC->Zobrist >> 32);
    tr->hole_high = tr->hole_low = DEPTH;
    tr->move = move;
    tr->value_high = tr->value_low = value;
    tr->years = YEARS;
    tr->stones = STONES;
    return;
    }
